#define _XOPEN_SOURCE 1
#define _XOPEN_SOURCE_EXTENDED 1
#include <unistd.h>
#include <fcntl.h>

int setblock(int fd, int set) {
  int const flags=fcntl(fd, F_GETFL, 0);
  int newflags;
  if (flags==-1)
    return setblock_getfl;
  if (set==0) newflags=flags| nonblock;
  else        newflags=flags&~nonblock;
  if (flags!=newflags)
    if (fcntl(fd, F_SETFL, newflags)==-1)
      return setblock_setfl;
  return setblock_success;
}
